#ifndef PLAYER_C
	#define PLAYER_C



	void movePlayer() {
		int nTraceDown = 0;
		
		VECTOR vecPlayerMoveSpeed;
		
		while(1) {
			if(nMovementAllowed) {
				nTraceDown = c_trace(my.x, vector(my.x,my.y,my.z-500), IGNORE_ME|IGNORE_PASSENTS|IGNORE_PASSABLE|IGNORE_SPRITES|USE_BOX);	
				vecPlayerMoveSpeed.z = -(nTraceDown - PLAYER_HEIGHT);
				
				vecPlayerMoveSpeed.x = (key_w - key_s) * (WALK_SPEED+key_shiftl*RUN_SPEED) * time_step;
				vecPlayerMoveSpeed.y = (key_a - key_d) * WALK_SPEED * time_step;
				
				my.pan -= mouse_force.x * time_step*MOUSE_SENSITIVITY;
				
				c_move(me, vecPlayerMoveSpeed.x, nullvector, IGNORE_PASSABLE | IGNORE_PASSENTS | GLIDE);

			}

			wait(1);
		}
	}

	void moveCamera() {
		while(1) {

			if (nMovementAllowed) {
				
				camera.pan = player.pan;
				
				camera.tilt = clamp(camera.tilt+mouse_force.y*time_step*MOUSE_SENSITIVITY, -85, 85);
				
				vec_set(camera.x,vector(player.x,player.y,player.z+PLAYER_HEIGHT));

			}

			wait(1);	
		}
	}

	action actPlayer() {
		
		player = me;
		
		set(me,INVISIBLE);
		
		movePlayer();
		moveCamera();
	}

	void allowMovement() {
		nMovementAllowed = 1;
	}

	void forbidMovement() {
		nMovementAllowed = 0;
	}

	int isMovementAllowed() {
		return nMovementAllowed;
	}
#endif